unit BMaxGTypes;

interface
uses windows,kol;
const last=-1;
const buyMetall='()';
const buyFuel='()';
const GlsrSize=11;
const IDPrg=0;
const IDGame=1;
const IDCurPlayer=2;
const IDMaxMap=3;
const IDGameMap=4;
const IDMdraw=5;
const IDCursor=6;
const IDUnit=7;
const IDCtrl=8;
const IDMapCell=9;
const IDUnitInfo=10;

const rtRaw=1;
const rtFuel=2;
const rtGold=3;
const Qty='';
const FTLeftClickOnEmpty=1;
const FTLeftClickOnMyUnit=2;
const FTLeftClickOnEnemy=3;
const FTLeftClickOnFriend=4;
const FTRightClickOnEmpty=5;
const FTRightClickOnMyUnit=6;
const FTRightClickOnEnemy=7;
const FTRightClickOnFriend=8;
const FTMouseMoveOnEmpty=9;
const FTMouseMoveOnMyUnit=10;
const FTMouseMoveOnEnemy=11;
const FTMouseMoveOnFriend=12;

type TXY = packed record X: integer;Y: integer;end;
type TMGSize = record size:byte;pos:array[1..10]of TXY;end;
type Theader=array[1..5]of byte;
type TMXRes = record metall,fuel,energy,humans,gold:longword;end;
type TMapMXRes = record cur,max:TMXRes;end;
type Tcurparams=record
   fires:byte;       
   Ammo:byte;        
   Hits:byte;
   Move:byte;
   gruz:TMXRes;
end;
procedure Stream2params(strm:PStream;params:TcurParams);
procedure Params2Stream(params:TcurParams;strm:PStream);
type TUoptions=record
   AutoTransfer:byte;
   LoadIn,LoadOut:byte;
end;
function stream2options(strm:PStream):TUoptions;

procedure options2stream(opts:TUoptions;strm:PStream);

type TstringgridfillType=set of (Fromrow1,Fromrow2,GruzInfo,GruzMax,ParamsInfo,PokupkaMode,UpgradeMode);

type terrtpes = array[0..6]of Shortint;

type Unittypes=array[0..4]of byte;

type UnitCanDO=array[0..13]of byte;
type UCanLoad=array[0..3]of byte;
type UCanConstruct=array[0..7]of byte;
type tresourcepoint=record qty:byte;rtype:byte;end;
type TRmap=record
   pos:TXY;
   res:array[0..2,0..2]of tresourcepoint;
end;
type TStartSector=record
   x,y:byte;
   player:byte;
end;
type twordbyte=packed record
   case integer of
   0: (idword:word);
   1: (idbyte:array [0..1]of byte);
end;

type Tmapsize=array[1..4]of byte;
type TmapSizeEx=packed record case integer of 0: (arr:Tmapsize);1: (x,y:Word);end;
type Tminimap=array[0..111,0..111]of byte;
type Tmap=array[0..111,0..111]of twordbyte;
type byte63l=array [0..63]of byte;
type byte63i=array [0..15]of LongWord;
type tlinearray=packed record
   case integer of
   0: (arrx1:array [0..63]of byte63l);
   1: (arrx2:array [0..63,0..63]of byte);
   2: (arrx01:array [0..63]of byte63i);
end;
type Tbitmaps=record
   data:array[0..63,0..63]of byte;
   kind:byte;
   pass:byte;
end;
type CLRTRGBQuad=packed record
   case integer of
   0: (rgb:TRGBQuad);
   1: (color:Cardinal);
end;
type TMpalette=array[0..255,1..3]of byte;
type TDPalette=array[0..255]of CLRTRGBQuad;
type bmfileheader=record
    Typf	:	word;     
    Size	:	longint;  
    Res1	:	word;     
    Res2	:	word;     
    OfBm	:	longint;
		   end;
bmInfoHeader = record    
    Size	:	longint;	
    Widt	:	longint;	
    Heig	:	longint;	
    Plan	:	word;	
    BitC	:	word;	
    Comp	:	longint;	
    SizI	:	longint;	
    XppM	:	longint;	
			     YppM : longint; 
			NCoL : longint; 
			NCoI : longint;
end;
bmHeader = record    
    f : bmFileHeader;	
    i : bmInfoHeader;	
    p : TDPalette;
end;
function wrt(strr:string;default:string='0'):string;

function equal(one,two:TerrTpes):boolean;overload;
function equal(one,two:TXY):boolean;overload;
function equal(one,two:Tmap):boolean;overload;

function summ(res:TMXRES):integer;overload;
function summ(one,two:TMXRES):TMxRes;overload;
function summ(one,two:Terrtpes):Terrtpes;overload;

function CanDO(Survey,Mine,Produce,
repair,reammo,refuel,transfer,disable,capture,beDisabled,
alienUnit,transport,research:byte;bulldozer:byte=0):UnitCanDO;overload;

function Utpe(Common,Infil,Submarine,Mine,airunit:byte):Unittypes;overload;

function SZ(x1,y1:smallint; x2:shortint=-100;y2:shortint=-100;x3:shortint=-100;y3:shortint=-100;x4:shortint=-100;y4:shortint=-100;x5:shortint=-100;y5:shortint=-100;x6:shortint=-100;y6:shortint=-100;x7:shortint=-100;y7:shortint=-100;x8:shortint=-100;y8:shortint=-100;x9:shortint=-100;y9:shortint=-100;x10:shortint=-100;y10:shortint=-100):TMGSize;overload;
function SZ2Word(s:TMGSize):word;
function MXres(metall,fuel,energy,humans,gold:longword):TMXRES;overload;

function moveterr(water,beach,land,mount,bridge,ruins,road:shortint;depot:shortint=-1):terrtpes;overload;
function Terr2Log(terr:terrtpes):string;

function CanLoad(Vehicle,Infantry,Ships,Air:byte):UCanLoad;overload;

function ProduceR(smalBLD,lrgBLD,lFact,hFact,AirPlant,MineLayer,Infantry,ships:byte):UCanConstruct;overload;

function XY(x,y:integer):TXY;overload;
function XY2Log(pos:TXY):String;
procedure XY2Stream(pos:TXY;strm:Pstream);
function Stream2XY(strm:Pstream):TXY;
function res(num,kind:byte):tresourcepoint;
function LargeRaw:TRmap;
function LargeFuel:TRmap;
function LargeGold:TRmap;

type TMoveCost=function (TerrType:terrtpes):integer of object;
type TObtacle=function (TerrType:terrtpes):terrtpes of object;
type FTMGSize=function :TMGSize of object;
type FTMXRES=function (res:string;qty:word=0):TMxRes of object;
type FTbuyEnable=function (buy:boolean=true;qty:word=1):boolean of object;
type FTUnitIcon=Function (name:string='';size:word=64;color:cardinal=clGray;mode:string=''):Pbitmap of object;
type TMaxGFunc=Procedure (Objs:array of PObj) of object;
type MaxFunc=record
   kind:byte;
   proc:TMaxGFunc;
end;
type MaxFuncArray=record
   procs:array of MaxFunc;
   count:integer;
end;
var pn:array[1..9]of string = ('Firepower','Firesmax','Firerange','AmmoMax','Armor','HitsMax','ScanRange','MoveMax','Cost');
var Glsr:array of PObj;

procedure Mxres2Stream(rs:TMXres;strm:Pstream);
function Stream2MXRes(strm:Pstream):TMxRes;
{$IFDEF BMGLOG}
var logpos:smallint=0;
procedure log(ss:string;pos:smallint=0);
{$ENDIF}

implementation
function res(num,kind:byte):tresourcepoint;
begin
   result.qty:=num;result.rtype:=kind;
end;
function LargeRaw:TRmap;
begin
   result.res[1,1]:=res(16,rtRaw);
   result.res[0,0]:=res(random(5)+4,rtFuel);
   result.res[0,2]:=res(random(5)+4,rtFuel);
   result.res[2,0]:=res(random(5)+0,rtFuel);
   result.res[2,2]:=res(random(5)+0,rtFuel);
   result.res[1,0]:=res(random(3)+0,rtGold);
   result.res[1,2]:=res(random(3)+0,rtGold);
end;
function LargeFuel:TRmap;
begin
   result.res[1,1]:=res(16,rtFuel);
   result.res[0,0]:=res(random(5)+4,rtRaw);
   result.res[0,2]:=res(random(5)+4,rtRaw);
   result.res[2,0]:=res(random(5)+0,rtRaw);
   result.res[2,2]:=res(random(5)+0,rtRaw);
   result.res[1,0]:=res(random(3)+0,rtGold);
   result.res[1,2]:=res(random(3)+0,rtGold);
end;
function LargeGold:TRmap;
begin
   result.res[1,1]:=res(16,rtGold);
   result.res[0,0]:=res(random(5)+4,rtFuel);
   result.res[0,2]:=res(random(5)+4,rtRaw);
   result.res[2,0]:=res(random(5)+0,rtRaw);
   result.res[2,2]:=res(random(5)+0,rtFuel);
end;
function Stream2MXRes(strm:Pstream):TMxRes;
begin
   strm.Read(result.metall,sizeof(result.metall));
   strm.Read(result.fuel,sizeof(result.fuel));
   strm.Read(result.energy,sizeof(result.energy));
   strm.Read(result.humans,sizeof(result.humans));
   strm.Read(result.gold,sizeof(result.gold));
end;
procedure Mxres2Stream(rs:TMXres;strm:Pstream);
begin
   strm.Write(rs.metall,sizeof(rs.metall));
   strm.Write(rs.fuel,sizeof(rs.fuel));
   strm.Write(rs.energy,sizeof(rs.energy));
   strm.Write(rs.humans,sizeof(rs.humans));
   strm.Write(rs.gold,sizeof(rs.gold));
end;
function summ(res:TMXRES):integer;overload;
begin
result:=res.metall+res.fuel+res.energy+res.humans+res.gold;
end;
function summ(one,two:TMXRES):TMXRes;overload;
begin
result.metall:=one.metall+two.metall;
result.fuel:=one.fuel+two.fuel;
result.energy:=one.energy+two.energy;
result.humans:=one.humans+two.humans;
result.gold:=one.gold+two.gold;
end;
function summ(one,two:Terrtpes):Terrtpes;overload;
var f1:integer;
begin
for f1:=0 to 6 do begin
   if two[f1]=1 then result[f1]:=two[f1] else result[f1]:=one[f1];
   if two[f1]=2 then result[f1]:=0;
end;
end;

function equal(one,two:TerrTpes):boolean;overload;
var f1:integer;
begin
result:=true;
for f1:=0 to 6 do if one[f1]<>two[f1] then result:=false;
end;

function equal(one,two:TXY):boolean;overload;
begin
result:=true;
if one.X<>two.X then result:=false;
if one.Y<>two.Y then result:=false;
end;
function XY(x,y:integer):TXY;overload;
begin
result.X:=x;result.Y:=y;
end;
function Stream2XY(strm:Pstream):TXY;
begin
   strm.read(result.x,sizeof(result.x));
   strm.read(result.y,sizeof(result.y));
end;

procedure XY2Stream(pos:TXY;strm:Pstream);
begin
   strm.Write(pos.x,sizeof(pos.x));
   strm.Write(pos.y,sizeof(pos.y));
end;
function XY2Log(pos:TXY):String;
begin
result:=int2str(pos.x)+'x'+int2str(pos.y);
end;
function CanLoad(Vehicle,Infantry,Ships,Air:byte):UCanLoad;overload;
begin
result[0]:=vehicle;
result[1]:=infantry;
result[2]:=ships;
result[3]:=Air;
end;

function ProduceR(smalBLD,lrgBLD,lFact,hFact,AirPlant,MineLayer,Infantry,ships:byte):UCanConstruct;
begin
result[0]:=smalBLD;
result[1]:=lrgBLD;
result[2]:=lFact;
result[3]:=hFact;
result[4]:=AirPlant;
result[5]:=MineLayer;
result[6]:=Infantry;
result[7]:=ships;
end;

function CanDO(Survey,Mine,Produce,
repair,reammo,refuel,transfer,disable,capture,beDisabled,
alienUnit,transport,research:byte;bulldozer:byte=0):UnitCanDO;overload;
begin

result[0]:=Survey;
result[1]:=Mine;
result[2]:=Produce;
result[3]:=repair;
result[4]:=reammo;
result[5]:=refuel;
result[6]:=transfer;
result[7]:=disable;
result[8]:=capture;
result[9]:=beDisabled;
result[10]:=alienunit;
result[11]:=transport;
result[12]:=research;
result[13]:=bulldozer;
end;

function Utpe(Common,Infil,Submarine,Mine,airunit:byte):Unittypes;overload;
begin

result[0]:=Common;
result[1]:=Infil;
result[2]:=Submarine;
result[3]:=Mine;
result[4]:=airunit;
end;
function SZ2Word(s:TMGSize):word;
begin
   if s.size=1 then result:=64 else result:=128;
end;
function SZ(x1,y1:smallint; x2:shortint=-100;y2:shortint=-100;x3:shortint=-100;y3:shortint=-100;x4:shortint=-100;y4:shortint=-100;x5:shortint=-100;y5:shortint=-100;x6:shortint=-100;y6:shortint=-100;x7:shortint=-100;y7:shortint=-100;x8:shortint=-100;y8:shortint=-100;x9:shortint=-100;y9:shortint=-100;x10:shortint=-100;y10:shortint=-100):TMGSize;overload;
begin
result.size:=1;
result.pos[1].x:=x1;
result.pos[1].y:=y1;
if x2<-99 then result.pos[2]:=result.pos[1]
  else begin result.size:=2;result.pos[2].x:=x1+x2;result.pos[2].y:=y1+y2;end;
if x3<-99 then result.pos[3]:=result.pos[1]
  else begin result.size:=3;result.pos[3].x:=x1+x3;result.pos[3].y:=y1+y3;end;
if x4<-99 then result.pos[4]:=result.pos[1]
  else begin result.size:=4;result.pos[4].x:=x1+x4;result.pos[4].y:=y1+y4;end;
if x5<-99 then result.pos[5]:=result.pos[1]
  else begin result.size:=5;result.pos[5].x:=x1+x5;result.pos[5].y:=y1+y5;end;
if x6<-99 then result.pos[6]:=result.pos[1]
  else begin result.size:=6;result.pos[6].x:=x1+x6;result.pos[6].y:=y1+y6;end;
if x7<-99 then result.pos[7]:=result.pos[1]
  else begin result.size:=7;result.pos[7].x:=x1+x7;result.pos[7].y:=y1+y7;end;
if x8<-99 then result.pos[8]:=result.pos[1]
  else begin result.size:=8;result.pos[8].x:=x1+x8;result.pos[8].y:=y1+y8;end;
if x9<-99 then result.pos[9]:=result.pos[1]
  else begin result.size:=9;result.pos[9].x:=x1+x9;result.pos[9].y:=y1+y9;end;
if x10<-99 then result.pos[10]:=result.pos[1]
  else begin result.size:=10;result.pos[10].x:=x1+x10;result.pos[10].y:=y1+y10;end;
end;
function moveterr(water,beach,land,mount,bridge,ruins,road:shortint;depot:shortint=-1):terrtpes;overload;
begin
result[0]:=water;
result[1]:=beach;
result[2]:=land;
result[3]:=mount;
result[4]:=bridge;
result[5]:=ruins;
result[6]:=road;

end;
function Terr2Log(terr:terrtpes):string;begin result:='(W'+int2str(terr[0])+',B'+int2str(terr[1])+',L'+int2str(terr[2])+',M'+int2str(terr[3])+','+int2str(terr[4])+','+int2str(terr[5])+','+int2str(terr[6])+',0)';end;

function MXres(metall,fuel,energy,humans,gold:longword):TMXRES;
begin
result.metall:=metall;
result.fuel:=fuel;
result.energy:=energy;
result.humans:=humans;
result.gold:=gold;
end;
procedure Stream2params(strm:PStream;params:TcurParams);
begin
strm.Read(params.fires,1);
strm.Read(params.Ammo,1);
strm.Read(params.Hits,1);
strm.Read(params.Move,1);
params.gruz:=Stream2MxRes(strm);
end;

procedure Params2Stream(params:TcurParams;strm:PStream);
begin
strm.Write(params.fires,1);
strm.Write(params.Ammo,1);
strm.Write(params.Hits,1);
strm.Write(params.Move,1);
MxRes2Stream(params.gruz,strm);
end;

function stream2options(strm:PStream):TUoptions;
begin
   strm.Read(result.AutoTransfer,1);
   strm.Read(result.LoadIn,1);
   strm.Read(result.LoadOut,1);
end;
procedure options2stream(opts:TUoptions;strm:PStream);
begin
   strm.Write(opts.AutoTransfer,1);
   strm.Write(opts.LoadIn,1);
   strm.Write(opts.LoadOut,1);
end;

function equal(one,two:Tmap):boolean;
var f1,f2:byte;
begin
result:=true;
for f1:=0 to 111 do
   for f2:=0 to 111 do

         if one[f1,f2].idword<>two[f1,f2].idword then result:=false;
end;
function wrt(strr:string;default:string='0'):string;

var t4,f4:byte;
var s1:string;
begin
     f4:=0; s1:='';
     for t4:=1 to length(strr) do begin
      if (strr[t4]='.')or(strr[t4]=',') then begin strr[t4]:=',';f4:=f4+1;end;
      if (strr[t4]='0')
       or (strr[t4]='1')
        or (strr[t4]='2')
         or (strr[t4]='3')
          or (strr[t4]='4')
           or (strr[t4]='5')
            or (strr[t4]='6')
             or (strr[t4]='7')
              or (strr[t4]='8')
               or (strr[t4]='9')
                or ((strr[t4]=',')and(f4=1))
                 or ((strr[t4]='-')and(length(s1)<1))
                 then s1:=s1+strr[t4];
     end;
     if s1='' then s1:=default;
 strr:=s1;
 result:=s1;
end;
{$IFDEF BMGLOG}
procedure log(ss:string;pos:smallint);
var f:textfile;
var ss1:string;
var f1:integer;
begin
assignfile(f,getstartdir+'maxgold.log');
if fileexists(getstartdir+'maxgold.log') then append(f) else rewrite(f);
setlength(ss1,logpos);for f1:=1 to logpos do ss1[f1]:=' ';
writeln(f,ss1+ss);
closefile(f);
Logpos:=Logpos+pos;
if logpos<0 then logpos:=0;

end;
{$ENDIF}
end.
