unit BMaxGPlayer;

interface
uses Kol,BMaxGTypes,BMaxGUnitsInfo,BMaxGGameMap, BMaxGDraw, BProcsPack, BMaxGObject;
type Tpokupki=record
   Utype:byte;
   gruz:TMXRes;
   cost:integer;
   count:integer;
   IdinListbox:integer;
end;
type TmaxplayerPositions=record
   scrcenter:TXY;
   BasePlace:TXY;
   MousePos:TXY;
end;
type TmaxPlayerInfo=record
   name:string;
   color:cardinal;
   password:string;
   condition:byte;
   turnscount:integer;
end;
type PNewPlayer=^TNewPlayer;
   TNewPlayer=object(TObj)
   Game:PObj;
   Pos:TmaxplayerPositions;
   playerID:byte;
   id:integer;
   info:TmaxPlayerInfo;
   money:integer;
   units:PUnits;
   upgradelevel:TUpgradeLevel;
   Pokupki:array of Tpokupki;
   procedure load(what:string);
   procedure pokupkiToKolMeMo(Where:Pcontrol);
   procedure pokupkiToKolListBox(Where:Pcontrol);
   function addPokupka(Tunt:PUnitupgradehistory;checkformoney:boolean=true;checkforbuy:boolean=true):integer;
   procedure sellpokupka(Tunt:PUnitupgradehistory;pid:integer;ask:boolean=true;pay:boolean=true);
   procedure PrepareToUnloadPokupka(LB:Pcontrol);
   procedure savetostream(Strm:Pstream);
   procedure loadfromstream(strm:Pstream);
   destructor destroy;virtual;
end;
Function CreatePNewPlayer:PNewPlayer;
procedure pokupki2stream(p:Tpokupki;Strm:Pstream);
function stream2pokupki(Strm:Pstream):Tpokupki;
implementation
uses bmaxgprg,BmaxGGame;
procedure pokupki2stream(p:Tpokupki;Strm:Pstream);
begin
   Mxres2Stream(p.gruz,strm);
   strm.Write(p.cost,sizeof(p.cost));
   strm.Write(p.count,sizeof(p.count));
   strm.Write(p.Utype,1);
end;
function stream2pokupki(Strm:Pstream):Tpokupki;
begin
   result.gruz:=Stream2MXRes(strm);
   strm.read(result.cost,sizeof(result.cost));
   strm.read(result.count,sizeof(result.count));
   strm.read(result.Utype,1);
end;
Function CreatePNewPlayer:PNewPlayer;
begin
   new(result,create);
   result.units:=NewUnits;

   result.Game:=nil;
   result.info.name:='';
   result.info.password:='';
   result.info.color:=0;
   result.info.condition:=0;
   result.info.turnscount:=0;
   result.money:=0;
   setlength(result.pokupki,0);
   result.load('StartData');
   result.pos.scrcenter:=xy(0,0);
end;

function TNewPlayer.addPokupka(Tunt: PUnitupgradehistory;checkformoney:boolean;checkforbuy:boolean):integer;
var f1,f2:integer;
var ok:boolean;
begin
result:=-1;
ok:=false;
if checkforbuy=false then ok:=true;
if ok=false then ok:=Tunt.info.buyEnable;
if ok then begin
  ok:=false;
  if checkformoney=false then ok:=true;
  if (money>=Tunt.Params(pn[9]))and(ok=false) then begin
     ok:=true;money:=money-Tunt.Params(pn[9]);
  end;
  if ok then begin
     f1:=high(pokupki)+1;
     if summ(tunt.info.GruzMAX)>0 then begin
        setlength(pokupki,f1+1);
        pokupki[f1].count:=0;
     end else begin
        for f2:=0 to high(pokupki) do begin
           if pokupki[f2].Utype=Tunt.SelfID then f1:=f2;
        end;
     end;
     if f1>high(pokupki) then setlength(pokupki,f1+1);
     pokupki[f1].Utype:=Tunt.SelfID;
     pokupki[f1].cost:=Tunt.Params(pn[9]);
     pokupki[f1].count:=pokupki[f1].count+1;
     pokupki[f1].gruz:=MxRes(0,0,0,0,0);
     result:=f1;
  end;
end;
end;

destructor TNewPlayer.destroy;
begin
game:=nil;

if units<>nil then begin units.clear(true);units.free;units:=nil;end;
if UpgradeLevel<>nil then begin
UpgradeLevel.free;
UpgradeLevel:=nil;
end;
inherited;
end;

procedure TNewPlayer.load(what: string);
var TMP:PUnitUpgradehistory;
begin
if what='NoUpgrades' then begin
   if UpgradeLevel=nil then begin
      UpgradeLevel:=TUpgradeLevel.Create;
      UpgradeLevel.load('Default');
   end;
   UpgradeLevel.load('ClearUpgrades');
end;
if what='StartData' then begin
   if UpgradeLevel=nil then UpgradeLevel:=TUpgradeLevel.Create else UpgradeLevel.clear;
   UpgradeLevel.load('Default');
end;
if what='StartPokupki' then begin
   setlength(pokupki,5);
   TMP:=UpgradeLevel.FindBy('Mining Station');if TMP=nil then exit; pokupki[0].Utype:=tmp.SelfID;pokupki[0].gruz:=MXRES(15,0,0,0,0);pokupki[0].cost:=tmp.Params('Cost')+3;pokupki[0].count:=1;
   TMP:=UpgradeLevel.FindBy('Power Generator');if TMP=nil then exit;pokupki[1].Utype:=tmp.SelfID;pokupki[1].gruz:=MXRES(0,0,0,0,0); pokupki[1].cost:=tmp.Params('Cost')  ;pokupki[1].count:=1;
   TMP:=UpgradeLevel.FindBy('Engineer');if TMP=nil then exit;       pokupki[2].Utype:=tmp.SelfID;pokupki[2].gruz:=MXRES(20,0,0,0,0);pokupki[2].cost:=tmp.Params('Cost')+4;pokupki[2].count:=1;
   TMP:=UpgradeLevel.FindBy('Constructor');if TMP=nil then exit;    pokupki[3].Utype:=tmp.SelfID;pokupki[3].gruz:=MXRES(40,0,0,0,0);pokupki[3].cost:=tmp.Params('Cost')+6;pokupki[3].count:=1;
   TMP:=UpgradeLevel.FindBy('Surveyor');if TMP=nil then exit;       pokupki[4].Utype:=tmp.SelfID;pokupki[4].gruz:=MXRES(0,0,0,0,0); pokupki[4].cost:=tmp.Params('Cost')  ;pokupki[4].count:=1;
end;
end;

procedure TNewPlayer.loadfromstream(strm: Pstream);
var f1,f2:integer;
begin
info.name:=Strm.ReadStrZ;
info.password:=Strm.ReadStrZ;
strm.Read(info.color,sizeof(info.color));
strm.Read(info.condition,1);
strm.Read(info.turnscount,sizeof(info.turnscount));
strm.Read(playerID,sizeof(playerID));
strm.Read(money,sizeof(money));
strm.Read(f2,sizeof(f2));
setlength(pokupki,f2+1);
for f1:=0 to f2 do begin
   pokupki[f1]:=stream2pokupki(strm);
end;
Upgradelevel.loadfromstream(strm);
units.loadfromstream(strm,false);
end;

procedure TNewPlayer.pokupkiToKolListBox(Where: Pcontrol);
var f1,ps,f2:integer;
var ss:string;
var tmp:TMXRes;
begin
f2:=where.CurIndex;
Where.Clear;where.Caption:='';
ps:=0;
for f1:=0 to high(pokupki) do begin
   ss:=' ';
   tmp:=upgradelevel.FindBy(pokupki[f1].Utype).info.GruzMAX;
   if summ(tmp)>0 then begin
      if summ(pokupki[f1].gruz)=0 then ss:='(empty)' else begin
         ss:=': ';
         if tmp.metall>0 then ss:=ss+'Metall('+int2str(pokupki[f1].gruz.metall)+'/'+int2str(tmp.metall)+')';
         if tmp.fuel>0 then ss:=ss+'Fuel('+int2str(pokupki[f1].gruz.fuel)+'/'+int2str(tmp.fuel)+')';
         if tmp.gold>0 then ss:=ss+'Gold('+int2str(pokupki[f1].gruz.gold)+'/'+int2str(tmp.gold)+')';
      end;
   end;
   Where.Add((int2str(pokupki[f1].count)+' '+upgradelevel.FindBy(pokupki[f1].Utype).info.ENGname)+ss);
   pokupki[f1].IdinListbox:=ps;inc(ps);
end;
where.CurIndex:=f2;
end;

procedure TNewPlayer.pokupkiToKolMeMo(Where: Pcontrol);
var f1:integer;
var ss:string;
var tmp:TMXRes;
begin
Where.Clear;
for f1:=0 to high(pokupki) do begin
   ss:=' ';
   tmp:=upgradelevel.FindBy(pokupki[f1].Utype).info.GruzMAX;
   if summ(tmp)>0 then begin
      if summ(pokupki[f1].gruz)=0 then ss:='(empty)' else begin
         ss:=': ';
         if tmp.metall>0 then ss:=ss+'Metall('+int2str(pokupki[f1].gruz.metall)+'/'+int2str(tmp.metall)+')';
         if tmp.fuel>0 then ss:=ss+'Fuel('+int2str(pokupki[f1].gruz.fuel)+'/'+int2str(tmp.fuel)+')';
         if tmp.gold>0 then ss:=ss+'Gold('+int2str(pokupki[f1].gruz.gold)+'/'+int2str(tmp.gold)+')';
      end;
   end;
   where.text:=where.text+(int2str(pokupki[f1].count)+' '+upgradelevel.FindBy(pokupki[f1].Utype).info.ENGname)+ss+#13#10;
end;
end;

procedure TNewPlayer.PrepareToUnloadPokupka(LB: Pcontrol);
var f1:integer;
var tunt:PUnitupgradehistory;
var cr:PBmaxCrsr;
begin
for f1:=0 to high(pokupki) do
  if pokupki[f1].IdinListbox=LB.CurIndex then begin
    tunt:=upgradelevel.FindBy(pokupki[f1].Utype);
    PGameMap(Glsr[IDGamemap]).generatemaskfor(tunt.info.canmove);
    cr:=PBmaxCrsr(Glsr[IDCursor]);
    cr.clear;
    glsr[IDUnitInfo]:=tunt;

    cr.draw:=ppck.standartIconDraw;

    cr.leftclickOnEmptyCell:=ppck.UnloadPokupkaClick;
    cr.leftclickOnMyUnit:=ppck.SelectUnloadedPokupka;
    glsr[IDCtrl]:=LB;
    PBmaxDraw(Glsr[IDMdraw]).draw(true);
    exit;
  end;
end;

procedure TNewPlayer.savetostream(Strm: Pstream);
var f1,f2:integer;
begin
Strm.WriteStrZ(info.name);
Strm.WriteStrZ(info.password);
strm.Write(info.color,sizeof(info.color));
strm.Write(info.condition,1);
strm.Write(info.turnscount,sizeof(info.turnscount));
strm.Write(playerID,sizeof(playerID));
strm.Write(money,sizeof(money));
f2:=high(pokupki);
strm.Write(f2,sizeof(f2));
for f1:=0 to f2 do begin
   pokupki2stream(pokupki[f1],strm);
end;
Upgradelevel.save2stream(strm);
units.save2stream(strm,false);
end;

procedure TNewPlayer.sellpokupka(Tunt: PUnitupgradehistory; pid: integer;ask:boolean;pay:boolean);
var f1,f2:integer;
var tmp:Tpokupki;
var ok:boolean;
begin
f2:=0;
for f1:=0 to high(pokupki) do
   if pokupki[f1].Utype=Tunt.SelfID then f2:=f2+pokupki[f1].count;
if f2=0 then exit;
ok:=false;
if ask=false then ok:=true;
if ok=false then ok:=Tunt.info.buyEnable(false,f2);
if ok then
 if pokupki[pid].count>0 then begin
  begin
     if pay then money:=money+pokupki[pid].cost;
     pokupki[pid].count:=pokupki[pid].count-1;
     if pokupki[pid].count<=0 then begin
        pokupki[pid].Utype:=255;
        pokupki[pid].cost:=0;
        pokupki[pid].gruz:=MxRes(0,0,0,0,0);
        repeat
        f2:=1;
        for f1:=0 to high(pokupki)-1 do begin
           if pokupki[f1].Utype=255 then begin
              tmp:=pokupki[f1];
              pokupki[f1]:=pokupki[f1+1];
              pokupki[f1+1]:=tmp;
              f2:=0;
           end;
        end;
        if pokupki[high(pokupki)].Utype=255 then setlength(pokupki,high(pokupki));
        until f2=1;

     end;
  end;
end;
end;

end.
